﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;

namespace GraphicsLayerDemos
{
  internal class CreateGraphicsLayerInGroup : Button
  {
    protected override void OnClick()
    {
      var map = MapView.Active.Map;
      var gl_param = new GraphicsLayerCreationParams { Name = "Graphics Layer in a group" };

      QueuedTask.Run(() => {

        //Add a graphics layer to a group layer...
        var group_layer = map.GetLayersAsFlattenedList().OfType<GroupLayer>().First();
        //Create GraphicsLayer inside the group
        LayerFactory.Instance.CreateLayer<GraphicsLayer>(gl_param, group_layer);
      });
    }
  }
}
