﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;

namespace GraphicsLayerDemos.Demo1
{
  internal class RemoveGraphicsLayer : Button
  {
    protected override void OnClick()
    {
      var map = MapView.Active.Map;
      QueuedTask.Run(() => {
        //Remove graphics layer
        var grahicsLayer = map.FindLayer("CIMPATH=map/first_graphics_layer.xml") as GraphicsLayer;
        map.RemoveLayer(grahicsLayer);

        //Remove graphics layer
        var grahicsLayers = map.FindLayers("Graphics Layer in a group").OfType<GraphicsLayer>();
        map.RemoveLayers(grahicsLayers);
      });
    }
  }
}
