﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;

namespace GraphicsLayerDemos.Demo2
{
  internal class UnGroupElements : Button
  {
    protected override void OnClick()
    {
      var graphicsLayer = MapView.Active.Map.GetLayersAsFlattenedList().OfType<GraphicsLayer>().FirstOrDefault();
      QueuedTask.Run( () => {
        //Ungroup grouped elements
        var selectedElements = graphicsLayer.GetSelectedElements().ToList();
        var elementsToUnGroup = new List<GroupElement>();
        foreach (var element in selectedElements)
        {
          var groupElement = element as GroupElement;
          if (groupElement != null)
            elementsToUnGroup.Add(groupElement);
        }      
        //UnGroup
        graphicsLayer.UnGroupElements(elementsToUnGroup);
      });
    }
  }
}
