﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ArcGIS.Core.CIM;
using ArcGIS.Core.Data;
using ArcGIS.Core.Geometry;
using ArcGIS.Desktop.Catalog;
using ArcGIS.Desktop.Core;
using ArcGIS.Desktop.Editing;
using ArcGIS.Desktop.Extensions;
using ArcGIS.Desktop.Framework;
using ArcGIS.Desktop.Framework.Contracts;
using ArcGIS.Desktop.Framework.Dialogs;
using ArcGIS.Desktop.Framework.Threading.Tasks;
using ArcGIS.Desktop.Layouts;
using ArcGIS.Desktop.Mapping;

namespace GraphicsLayerDemos.Demo2
{
  internal class UsingCIMGraphics : MapTool
  {
    public UsingCIMGraphics()
    {
      IsSketchTool = true;
      SketchType = SketchGeometryType.Rectangle;
      SketchOutputMode = SketchOutputMode.Map;
    }

    protected override Task OnToolActivateAsync(bool active)
    {
      return base.OnToolActivateAsync(active);
    }

    protected override Task<bool> OnSketchCompleteAsync(Geometry geometry)
    {
      GraphicsLayer graphicsLayer = MapView.Active.Map.TargetGraphicsLayer;
      //Use the sketch geometry
      Polygon polygonToCreate = geometry as Polygon;
      QueuedTask.Run(() => {
        CIMPolygonSymbol poly_symbol = SymbolFactory.Instance.ConstructPolygonSymbol(ColorFactory.Instance.GreenRGB);
        //create a CIMGraphic using the
        //Selection geometry and the symbol
        var cimPolygonGraphic = new CIMPolygonGraphic()
        {
          Symbol = poly_symbol.MakeSymbolReference(), 
          Polygon = polygonToCreate  
        };
        //Create and add GraphicElement to the layer using the CIMGraphic
        GraphicElement ge = graphicsLayer.AddElement(cimPolygonGraphic);
        //Get the CIMGraphic from the GraphicElement
        var cimGraphic = ge.GetGraphic() as CIMPolygonGraphic;
      });
      return base.OnSketchCompleteAsync(geometry);
    }
  }
}
